class Spectrum extends Element {
    var colors;
    var lower, lowercolor, upper, uppercolor;
    var active;
    
    function Spectrum(parent, name, y, width, height) {
        init(parent);
        clip._y = y;
        colors = [];
        for (var x = 0; x < width; x++) {
            var line = addclip();
            line.lineStyle(1, RGB.black);
            line.moveTo(x, 0);
            line.lineTo(x, height);
            colors.push(new Color(line));
        }
        
        lower = addclip();
        lower.beginFill(RGB.black);
        lower.moveTo(0, 0);
        lower.lineTo(0, height);
        lower.lineTo(1, height);
        lower.lineTo(1, 0);
        lower.endFill();
        lowercolor = new Color(lower);
        
        upper = addclip();
        upper.beginFill(RGB.black);
        upper.moveTo(0, 0);
        upper.lineTo(0, height);
        upper.lineTo(-1, height);
        upper.lineTo(-1, 0);
        upper.endFill();
        upper._x = width;
        uppercolor = new Color(upper);

        var spectrum = this;
        clip.onPress = function() {
            if (spectrum.clip._xmouse < 80) {
                spectrum.active = !spectrum.active;
                parent.elect();
            } else {
                parent.select_point(spectrum, spectrum.clip._xmouse);
            }
        }

/* plastic */
        //var gc = [0xffffff, 0xffffff, 0xffffff, 0, 0],
        //    ga = [70, 95, 0, 0, 20], gr = [0, 30, 80, 100, 255];
/* paper */
        var gc = [0xffffff, 0xffffff, 0, 0];
        var ga = [24, 0, 0, 16];
        var gr = [0, 50, 100, 255];
        var gm = {matrixType: "box", x: 0, y: 0, w: 1, h: height, r: Math.PI/2};
 
        var texture = addclip();
        texture.beginGradientFill("linear", gc, ga, gr, gm);
        texture.moveTo(0, 0);
        texture.lineTo(0, height);
        texture.lineTo(width, height);
        texture.lineTo(width, 0);
        texture.endFill();
        
        var text = addtext(4, 4, width, height);
        var format = new TextFormat();
        format.size = 16;
        format.font = 'Arial';
        format.color = RGB.white;
        format.italic = true;
        format.bold = false;
        text.text = name;
        text.setTextFormat(format);
    }
    
    function set(x, color) {
        colors[x].setRGB(color || RGB.grey(0.6));
    }
    
    function setlower(size, color) {
        lower._xscale = size * 100;
        lowercolor.setRGB(color || RGB.grey(0.6));
    }
    
    function setupper(size, color) {
        upper._xscale = size * 100;
        uppercolor.setRGB(color || RGB.grey(0.6));
    }
}
